/*******************************************************************************
* Copyright (C) 2012-2013 Intel Corp. All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*  - Redistributions of source code must retain the above copyright notice,
*    this list of conditions and the following disclaimer.
*
*  - Redistributions in binary form must reproduce the above copyright notice,
*    this list of conditions and the following disclaimer in the documentation
*    and/or other materials provided with the distribution.
*
*  - Neither the name of Intel Corp. nor the names of its
*    contributors may be used to endorse or promote products derived from this
*    software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
* ARE DISCLAIMED. IN NO EVENT SHALL Intel Corp. OR THE CONTRIBUTORS
* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
* POSSIBILITY OF SUCH DAMAGE.
*******************************************************************************/


#ifndef TBT_FW_UPDATE_LIB_H
#define TBT_FW_UPDATE_LIB_H

enum TBTDRV_STATUS
{
	TBTDRV_STATUS_OK,                                        
    TBTDRV_INVALID_PARAMETER_ERROR,   
    TBTDRV_INSUFFICIENT_RESOURCES_ERROR,
    TBTDRV_INTERNAL_ERROR,
    TBTDRV_DRIVER_LOAD_ERROR,
	TBTDRV_UNSUPPORTED,
	TBTDRV_HANDLE_NOT_FOUND,
	TBTDRV_OS_NOT_SUPPORTED,
	TBTDRV_UNKNOWN_ERROR,
    TBTDRV_STATUS_SIZE
};

TBTDRV_STATUS fw_update_check_driver_connection();

TBTDRV_STATUS fw_update_perform_update(unsigned int buffer_size, unsigned char *buffer);

TBTDRV_STATUS fw_update_get_nvm_version(unsigned int *nvm_version);

#endif // TBT_FW_UPDATE_LIB_H
